﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public bool IsAutomatic;
        public float AutomaticInterval;
        private AudioSource Audio;
        public const float PixelSize = Global.MetricMultiplier / 35f;
        public static void Main()
        {
            Cyborg.Initialise();  

            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "CTTC- Magic Rope Power Wand",
                    DescriptionOverride = "(Activate it to Use It)", 
                    CategoryOverride = ModAPI.FindCategory("Melee"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand.png"); 
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.AddComponent<EMP9>();

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("TimeHam.wav");
                        //Audio.Play(); 

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(1f, 1f, 1f, 0.065f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Scale Power Wand",
         DescriptionOverride = "Effects Dures 10 Seconds (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thum4.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(0f, 1f, 0f, 0.062f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîé");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 5f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(0f, 300f, 0f, 300f);
                        };
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Freeze Power Wand",
         DescriptionOverride = "Freeze The Aimed Objects (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb6.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(1f, 1f, 0f, 0.065f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.12f, 0.006f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.12f, -0.006f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 1f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 300f, 0f, 300f);
                        };
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Smash Power Wand",
         DescriptionOverride = "Smash The Aimed Object On The Ground (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb4.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(0f, 0.5f, 1f, 0.062f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈÈ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 5f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(0f, 140f, 300f, 300f);
                        };
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Black Hole Power Wand",
         DescriptionOverride = "Create A Black Hole On The Aimed Objects (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb1.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(0.65f, 0f, 1f, 0.072f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈÉ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 6f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 0f, 300f, 300f);
                        };
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Gravity Power Wand",
         DescriptionOverride = "Change The Gravity Of The Aimed Object (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb2.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(0.6f, 0.6f, 1f, 0.072f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈèè");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 6f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(160f, 160f, 300f, 300f);
                        };
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Incineration Power Wand",
         DescriptionOverride = "Make The Aimed Objects Explode 5 Times And Gets Incinerated At The End (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb7.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(1f, 0f, 0f, 0.072f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈÈÈÈ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 100f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 0f, 0f, 300f);
                        };
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Rainbow Power Wand",
         DescriptionOverride = "Change The Color Of The Aimed Object (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb3.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.1f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈÈÈÈÈ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 100f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 0f, 0f, 300f);
                        };
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "CTTC- Slicing Shockwave Power Wand",
         DescriptionOverride = "Create A Slicing Shockwave At The Aimed Objects (Activate it to Use It)",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb5.png"),
         AfterSpawn = (Instance) =>
	    {

                        var childObject11 = new GameObject();
                        childObject11.transform.SetParent(Instance.transform);
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.color = new Color(1f, 0.5f, 0f, 0.072f);
                        childSprite11.sprite = ModAPI.LoadSprite("WandPower2.png");
                        childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite11.sortingLayerName = "Top";

                        foreach (var hitbox in Instance.GetComponents<Collider2D>())
                        {GameObject.Destroy(hitbox);}
                        var box1 = Instance.AddComponent<BoxCollider2D>();
                        box1.offset = new Vector2(-0.1f, 0f);
                        box1.size = new Vector2(0.1f, 0.111f);
                        var box11 = Instance.AddComponent<BoxCollider2D>();
                        box11.offset = new Vector2(0.1f, 0f);
                        box11.size = new Vector2(-0.1f, -0.111f);
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("íàïðàâîÈÈÉÉ");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wand2.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tetrisShot.wav");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 6f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Instance.FixColliders();

                        Instance.AddComponent<UseEventTrigger>().Action = () =>                      
                        {
                        var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(Instance.transform.position.x, Instance.transform.position.y));
                        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 150f, 0f, 300f);
                        };
                    }
                }
            );

//---------------------
//     WAND BOLTS  
//---------------------

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈÈ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(3f, 1f);
            Instance.AddComponent<Hup>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.05f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.05f;
            line.endColor = Color.clear;
            line.startColor = new Color(0f, 1f, 1f, 0.55f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈÈÈÈ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(3f, 1f);
            Instance.AddComponent<Exp>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.05f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.05f;
            line.endColor = Color.clear;
            line.startColor = new Color(1f, 0f, 0f, 0.55f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈÈÉÉ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(3f, 1f);
            Instance.AddComponent<Zone>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.05f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.05f;
            line.endColor = Color.clear;
            line.startColor = new Color(1f, 0.5f, 0f, 0.55f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈÈÈÈÈ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(3f, 1f);
            Instance.AddComponent<Rain>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.05f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.05f;
            line.endColor = Color.clear;
            line.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.55f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîé",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.22f, 0.95f);
            Instance.AddComponent<chainBehaviour>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.045f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.0288f;
            line.endColor = Color.clear;
            line.startColor = new Color(0f, 1f, 0f, 0.5f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.22f, 0.95f);
            Instance.AddComponent<Frouze>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.045f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.0488f;
            line.endColor = new Color(1f, 1f, 0f, 0.5f);
            line.startColor = new Color(1f, 1f, 0f, 0.5f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîÈèè",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("timeball.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(0.6f, 0.6f, 1f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.22f, 0.95f);
            Instance.AddComponent<Boul>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.045f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.0488f;
            line.endColor = Color.clear;
            line.startColor = new Color(0.6f, 0.6f, 1f, 0.5f);
            line.sortingLayerName = "Background";
            Instance.FixColliders();
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Decimator"),
         NameOverride = "íàïðàâîÈÉ",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.1f, 0.1f);
            Instance.AddComponent<Hole>();
            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.035f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.time = 0.0488f;
            line.endColor = Color.clear;
            line.startColor = new Color(1f, 0f, 1f, 0.5f);
            line.sortingLayerName = "Background";
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.255f;
            var childObject11 = new GameObject();
            childObject11.transform.SetParent(Instance.transform);
            childObject11.transform.localPosition = new Vector3(0, 0f);
            childObject11.transform.localScale = new Vector3(0.7f, 0.7f);
            var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
            childSprite11.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite11.color = new Color(0.5f, 0f, 0.6f, 0.1f);
            childSprite11.sprite = ModAPI.LoadSprite("timeball.png");
            childSprite11.sortingLayerName = "Top";
            Instance.FixColliders();
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîèè",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.22f, 0.95f);
            Instance.AddComponent<Froz>();
            Instance.FixColliders();
                    }
                }
            );

	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"),
         NameOverride = "íàïðàâîèèè",
         DescriptionOverride = "",
         CategoryOverride = ModAPI.FindCategory(""),
         AfterSpawn = (Instance) =>
	    {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Quantum.png");
            Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0f);
            Instance.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Nothing");
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            Instance.transform.localScale = new Vector3(0.22f, 0.95f);
            Instance.AddComponent<LaserBehave>();
            Instance.FixColliders();
                    }
                }
            );
       }

     public class Hammer : MonoBehaviour 
     {
     public void Awake()
     {
     foreach (var hitbox in gameObject.GetComponents<BoxCollider2D>()){GameObject.Destroy(hitbox);}
     StartCoroutine("Cttc12");
     }
       
    public void Use(){foreach (var hitbox in gameObject.GetComponents<BoxCollider2D>()){GameObject.Destroy(hitbox);} StartCoroutine("CttcTest");}
    
    IEnumerator Cttc1125()
    {
     yield return new WaitForSeconds(0.001f);
     //StartCoroutines();
    }

    IEnumerator Cttc1()
    {
     yield return new WaitForSeconds(0.001f);
UnityEngine.Object.Destroy(gameObject.AddComponent<Hammer>());
UnityEngine.Object.Destroy(gameObject.GetOrAddComponent<Hammer>());
     gameObject.AddComponent<Hammer>();
    }

    IEnumerator Cttc12()
    {
     yield return new WaitForSeconds(0.001f);
     //yield return Start();
     var box111 = gameObject.AddComponent<BoxCollider2D>();
     //box111.gameObject.AddComponent<HammerBehaviour>();
     box111.offset = new Vector2(0f, 0.15f);
     box111.size = new Vector2(0.0322f, 1.3f);
     ModAPI.Notify("Retracted");
    }

    IEnumerator CttcTest(){
     yield return new WaitForSeconds(0.001f);
     foreach (var hitbox in gameObject.GetComponents<BoxCollider2D>()){GameObject.Destroy(hitbox);}
     gameObject.AddComponent<UseEventTrigger>().Action = () =>                      
      {
     StartCoroutine("Cttc1");
     ModAPI.Notify("Retracted");
      };

     //StopAllCoroutines();
      }
   }

    public class HammerBehaviour : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            Audio.Play(); 
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(other.transform.position.x, other.transform.position.y));
             var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 0f, 0f, 300f);
             other.gameObject.AddComponent<HammerNext>();

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 1;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class HammerNext : MonoBehaviour
    {
    public void Awake()
    {
        StartCoroutine("Ctt1112");
    }
    IEnumerator Ctt1112()
    {
        gameObject.AddComponent<FreezeBehaviour>();
        yield return new WaitForSeconds(0.25f);
        ExplosionCreator.CreatePulseExplosion(this.transform.position, 1f, 1, false);
        this.gameObject.SendMessage("Crush", SendMessageOptions.DontRequireReceiver);
    }
  }
    public class CannonBehaviour : MonoBehaviour
    {
    public void Use()
    {
        StartCoroutine("Ctt145");
    }
    IEnumerator Ctt145()
    {
        yield return new WaitForSeconds(0.001f);
        var light = ModAPI.CreateLight(this.gameObject.transform, new Color(1f, 0f, 0f), 4.5f, 4.5f);
        light.transform.localPosition = new Vector3(0.85f, 0f);
        yield return new WaitForSeconds(23f);
        ModAPI.Notify("start");
        this.gameObject.AddComponent<handBehaviour>();
        UnityEngine.Object.Destroy(light);
        UnityEngine.Object.Destroy(ModAPI.CreateLight(this.gameObject.transform, new Color(1f, 0f, 0f), 4.5f, 4.5f));
        ModAPI.Notify("end");
        yield return new WaitForSeconds(0.25f);
        UnityEngine.Object.Destroy(this.gameObject.GetComponent<handBehaviour>());
    }
  }

    public class Froz : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            //Audio.Play(); 
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<EMP3>();
             other.gameObject.AddComponent<EMP3>();
             other.gameObject.AddComponent<EMP3>();
             other.gameObject.AddComponent<EMP3>();
	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 1;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class LaserBehave : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            //Audio.Play(); 
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<Behaviour>();
             other.gameObject.AddComponent<Behaviour>();
             other.gameObject.AddComponent<Behaviour>();
             other.gameObject.AddComponent<Behaviour>();


	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 1;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class LaserBomb : MonoBehaviour
    {
    public void Use()
    {
        StartCoroutine("Ctt321");
    }
    IEnumerator Ctt321()
    {
        this.gameObject.AddComponent<FreezeBehaviour>();
        yield return new WaitForSeconds(0.001f);
        var effect = ModAPI.CreateParticleEffect("Disintegration", new Vector2(this.transform.position.x, this.transform.position.y));
        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 0f, 0f, 300f);
        GameObject Cyborg;
        Cyborg = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("íàïðàâîèèè").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0), this.transform.parent);
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("íàïðàâîèèè"), Cyborg);
        yield return new WaitForSeconds(0.5f);
        var effect2 = ModAPI.CreateParticleEffect("Explosion", new Vector2(this.transform.position.x, this.transform.position.y));
        var main2 = effect2.GetComponent<ParticleSystem>().main;main2.startColor = new Color(300f, 0f, 0f, 300f);
	UnityEngine.Object.Destroy(this.gameObject);
	UnityEngine.Object.Destroy(this.gameObject.GetComponent<Behaviour>());
    }
  }
    public class Brighten : MonoBehaviour
    {
        public bool Activated = true;
        public GameObject Paint = new GameObject("Lighter");
        public Color32 Colour;
        public float TargetCharge = 0f;
        public Sprite PaintSprite;
        public LightSprite Light;

        public void UpdateGlow()
        {
            if(Activated == true)
            {
                Light.Brightness = 0f;
                Paint.GetComponent<SpriteRenderer>().color = Colour;
            }
            else if(Activated == false)
            {
                Light.Brightness = 0f;
                Paint.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
            }
        }

        void Start()
        {
            Paint.transform.parent = gameObject.transform;
            Paint.transform.rotation = gameObject.transform.rotation;
            Paint.transform.localPosition = new Vector3(0f, 0f);
            Paint.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Paint.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = PaintSprite;
            Sprite.material = ModAPI.FindMaterial("Sprites-Default");
            Sprite.color = new Color32(0, 0, 0, 100);

            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder = +50;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
            UpdateGlow();
        }

        void Use() 
        {
            Activated = !Activated;
            UpdateGlow();
        }

        void Update() 
        {
            if(Activated == true)
            {
            }
            else
            {
            }
         }
       }
    public class Frouze : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav"); 
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<FreezeBehaviour>();
	     UnityEngine.Object.Destroy(gameObject);

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Hup : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<Grav>();
	     UnityEngine.Object.Destroy(gameObject);

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Grav : MonoBehaviour
    {
    private AudioSource audio;
    private AudioSource Audio;
    private LightSprite light;
    public void Awake()
    {
        StartCoroutine("Ctt1");
    }
    IEnumerator Ctt1()
    {
        audio = this.gameObject.GetOrAddComponent<AudioSource>();
        audio.spatialBlend = 0.1f;
        audio.minDistance = 1;
        audio.maxDistance = 3;
        audio.playOnAwake = false;
        audio.loop = true;
        audio.clip = Cyborg.PlasmaPistolLoop;
        yield return new WaitForSeconds(0.001f);
        this.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
        this.transform.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, 0.0378f);

        this.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -10f;

        yield return new WaitForSeconds(1f);
        //this.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
        //this.transform.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 1f);
        var effect = ModAPI.CreateParticleEffect("BigZap", new Vector2(this.transform.position.x, this.transform.position.y));
        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(0f, 100f, 300f, 300f);

        this.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 10f;

        yield return new WaitForSeconds(2.5f);
        var effect2 = ModAPI.CreateParticleEffect("Explosion", new Vector2(this.transform.position.x, this.transform.position.y));
        var main2 = effect2.GetComponent<ParticleSystem>().main;main2.startColor = new Color(0f, 300f, 300f, 300f);
        this.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
        this.transform.BroadcastMessage("Disintegrate", SendMessageOptions.DontRequireReceiver);
        this.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
        this.transform.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 1f);
        this.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
    }
  }
    public class Hole : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             gameObject.transform.GetComponent<PhysicalBehaviour>().Charge = 1000000000;

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Boul : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<Let>();
	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Let : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = UnityEngine.Random.value;
             gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -UnityEngine.Random.value;
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Exp : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<Plo>();
	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Plo : MonoBehaviour
    {
    private AudioSource audio;
    private AudioSource Audio;
    private LightSprite light;
    public void Awake()
    {
        StartCoroutine("Ctt1");
    }
    IEnumerator Ctt1()
    {
        yield return new WaitForSeconds(0.001f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
        ModAPI.CreateParticleEffect("BigExplosion", new Vector2(this.transform.position.x, this.transform.position.y));
        ExplosionCreator.CreatePulseExplosion(transform.position, 100f, 1000, true);
        yield return new WaitForSeconds(0.5f);
	UnityEngine.Object.Destroy(this);
    }
  }
    public class Rain : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
            other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.055f);
             other.gameObject.AddComponent<Count>();
	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Count : MonoBehaviour
    {
    private AudioSource audio;
    private AudioSource Audio;
    private LightSprite light;
    public void Awake()
    {
        StartCoroutine("Ctt1");
    }
    IEnumerator Ctt1()
    {
        this.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("VeryBright");
        yield return new WaitForSeconds(1f);
        this.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(0, 0, 0, 1f);
        this.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
        this.transform.BroadcastMessage("Disintegrate", SendMessageOptions.DontRequireReceiver);
    }
  }
    public class Zone : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = true;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             var effect = ModAPI.CreateParticleEffect("Explosion", new Vector2(other.transform.position.x, other.transform.position.y));
             var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 150f, 0f, 300f);
             //other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.2f, 0f, 0.055f);
             other.gameObject.AddComponent<Sliced>();
	     UnityEngine.Object.Destroy(gameObject);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class Sliced : MonoBehaviour
    {
    private AudioSource audio;
    private AudioSource Audio;
    private LightSprite light;
    public void Awake()
    {
        StartCoroutine("Ctt1");
    }
    IEnumerator Ctt1()
    {
        var effect = ModAPI.CreateParticleEffect("Explosion", new Vector2(this.transform.position.x, this.transform.position.y));
        var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(300f, 150f, 0f, 300f);
        this.gameObject.AddComponent<Field>();
        yield return new WaitForSeconds(0.5f);
        UnityEngine.Object.Destroy(this.gameObject.GetComponent<Field>());
        this.transform.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1;
        this.transform.BroadcastMessage("Disintegrate", SendMessageOptions.DontRequireReceiver);
    }
  }
    public class Field : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;

        public void Awake()
        {
            Ruka = gameObject;
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(10f, 10f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerStay2D(Collider2D other)
        {

            if(other.gameObject.GetComponent<Awake5>() == null & other.gameObject.GetComponent<ArmBehaviour>() == null)
            {
              other.transform.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0;
              other.transform.BroadcastMessage("Slice", SendMessageOptions.DontRequireReceiver);
              other.transform.BroadcastMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
             }
          } 
       }
     }
  }